'use strict';

AS.OPTIONS.locale = "ru";
AS.OPTIONS.coreUrl = "http://intern-dev.arta.kz/Synergy/";

function CreateAuthForm(){

	$(".saveBtn").hide();
	
	var forma = document.createElement("form");
	forma.className = "login-form";
	forma.setAttribute('id',"login-form");
	forma.setAttribute('id',"login-form");
	forma.setAttribute('align',"center");
	
	var authHeader = document.createTextNode('Введите логин и пароль');
	var authErr = document.createTextNode('Неверный логин или пароль');
	
	var Hdiv = document.createElement("div");
	Hdiv.className = "header";
	Hdiv.appendChild(authHeader);
	
	var Ediv = document.createElement("div");
	Ediv.className = "error";
	Ediv.appendChild(authErr);
	Ediv.setAttribute('id',"error");
	
	var textInp = document.createElement("input");
	textInp.className = "login";
	textInp.setAttribute('type',"text");
	textInp.setAttribute('name',"login");
	textInp.setAttribute('id',"login");
	textInp.setAttribute('placeholder',"Логин");
	textInp.setAttribute('align',"center");
	
	var pasInp = document.createElement("input");
	pasInp.className = "password";
	pasInp.setAttribute('type',"password");
	pasInp.setAttribute('name',"password");
	pasInp.setAttribute('id',"password");
	pasInp.setAttribute('placeholder',"Пароль");
	pasInp.setAttribute('align',"center");

	var submitBtn = document.createElement("input");
	submitBtn.className = "submit";
	submitBtn.setAttribute('type',"submit");
	submitBtn.setAttribute('value',"Войти");
	submitBtn.setAttribute('id',"submit");
	submitBtn.setAttribute('align',"center");

	forma.appendChild(Hdiv);
	forma.appendChild(Ediv);
	forma.appendChild(textInp);
	forma.appendChild(pasInp);
	forma.appendChild(submitBtn);

	document.getElementById("authForm").appendChild(forma);
	authFunc();
};

function ShowMessage(message){
	if(message.length > 30){
		$(".msg").css({'top': '20%'})
	} else $(".msg").css({'top': '34%'})
	$(".MsgRect").show();
	document.getElementById("msg").innerHTML = message;
	setTimeout(function(){
		$(".MsgRect").hide();
	}, 3000);
};

var user;
var portal = {
	
    player : null,
  
    clearPlayer : function() {
	    if(portal.player) {
            portal.player.destroy();
        }
    },
 
    createPlayer : function(){
        portal.clearPlayer();
        portal.player = AS.FORMS.createPlayer();
		AS.FORMS.bus.on(AS.FORMS.EVENT_TYPE.formShow, function (event, model, view) {
			if (model.formCode === "timesheet") {
                model.on(AS.FORMS.EVENT_TYPE.dataLoad, function() {
                    portal.main(portal.player.view.getViewWithId("main_script"), portal.player.model.getModelWithId("main_script"));
				});
			}
		});
		
		var formExistance;
		////формирование Пн и Вскр для формирования поискового запроса по форме
		var cur_date = new Date();
		var StrPeriod = timeComputing(cur_date); //строка Пнд+" "+Вскр
		var StrMonday = StrPeriod.substring(0, 10);
		var StrSunday = StrPeriod.substring(11);
		
		AS.FORMS.ApiUtils.simpleAsyncGet("rest/api/person/auth", function(userData){	
			AS.FORMS.ApiUtils.simpleAsyncGet("rest/api/asforms/search?modifiedFrom="+StrMonday+"&modifiedTo="+StrSunday+"&formCode=timesheet&field=ts_author&type=partial&recordsCount=1&search="+userData.lastname, function(success){ 
				AS.SERVICES.hideWaitWindow();
				portal.player.view.setEditable(true);
				portal.player.showFormData("097a00e2-430c-436d-92e5-c2ea8edc5b30", 1, success);
				portal.player.view.appendTo($('#form_player_div'));
				ShowMessage("Документ успешно открыт!");
				var formExistance = true;
			}, 'json', function(){formExistance = false;}); 
				
			if (formExistance)
			{
				AS.FORMS.ApiUtils.simpleAsyncGet('rest/api/registry/create_doc?registryCode=registry_timesheets', function(result){
					if(result.errorCode != "0") {   
						AS.SERVICES.hideWaitWindow();
						ShowMessage("Ошибка во время создания документа..");					   
						return;
					} else {
						AS.SERVICES.hideWaitWindow();
						portal.player.view.setEditable(true);
						portal.player.showFormData(result.documentID, 0, result.dataUUID);
						portal.player.view.appendTo($('#form_player_div'));
						ShowMessage("Документ успешно создан!");
					}
				}, 'json');
			}
		});		
	},
  
	saveData : function(){
		var errors = portal.player.model.getErrors();
        if(errors.length > 0) {
			AS.SERVICES.hideWaitWindow();
            ShowMessage("Введите все обязательные поля");
            return;
		}
		
		var data = portal.player.model.asfDataId;
		portal.player.saveFormData(function(data){
			if(_.isUndefined(data)){
				AS.SERVICES.hideWaitWindow();
				ShowMessage("Во время сохранения данных возникла ошибка");
			} else {
				AS.SERVICES.hideWaitWindow();
				ShowMessage("Данные сохранены");
			}
		});
	},
	
	main: function (view, model) {
		var serverDateTime = portal.player.model.getModelWithId("ts_date_created").value;
		var period = timeComputing(serverDateTime);
		var StrMonday = period.substring(0, 10);
		var StrSunday = period.substring(11);
		portal.player.model.getModelWithId("ts_period_date_from").setValue(StrMonday);
		portal.player.model.getModelWithId("ts_period_date_to").setValue(StrSunday);	
		
		portal.player.model.on("valueChange", function(){
			countingScore();
		});
	}	
};
	
function countingScore(){
		////Расчет итогового количества часов происходит при нажатии кнопки сохранения
    var tsTable = portal.player.model.playerModel.getModelWithId('ts_timesheet_table');
	var thModel = portal.player.model.playerModel.getModelWithId('ts_total_hours');
	var days = {'monday': 0, 'tuesday': 0, 'wednesday': 0, 'thursday': 0, 'friday': 0, 'saturday': 0, 'sunday': 0};;
  
    for(var i in days) {
        tsTable.modelBlocks.forEach(function(modelBlock) {
            modelBlock.forEach(function (m) {
                if (m.asfProperty.id === i) {
                    var n = parseFloat(m.getValue());
                    if(_.isNaN(n)){
                       n = 0;
                    } 
                    days[i] = days[i] + n;
                }
            });
        });    
    }

    var totalHours = 0;
    for(var n in days) {
        totalHours += days[n];
        jQuery('#ts_timesheet_table_total_'+n).text(days[n]);
    }
	
	thModel.setValue(totalHours.toString());
};
		
function timeComputing(serverDateTime){
	function zeroCheck(num){
		if (num <= 9) {num = "0"+ num;}
		return num;
	};
		var WeekDay = new Date(serverDateTime);
		WeekDay = WeekDay.getDay();
		var shift = 7 - WeekDay;	
		var sunday = new Date(serverDateTime);
		sunday.setDate(sunday.getDate() + shift);
		var monday = new Date(serverDateTime);
		monday.setDate(sunday.getDate() - 6);
		var StrSunday = sunday.getFullYear() + "-" + zeroCheck(sunday.getMonth()+1) + "-" + zeroCheck(sunday.getDate());
		var StrMonday = monday.getFullYear() + "-" + zeroCheck(monday.getMonth()+1) + "-" + zeroCheck(monday.getDate());
		return StrMonday+" "+StrSunday;
};

//переменные для WaitCircles();
var currentTime = Date.now(),
r = 40,
left = '',
Top = '',
alpha = 2 * 3.14;

function WaitCircles(num){
	var count = num;
	var t;
	let startTime = setInterval(function(count){
		switch(num){
			case '1':
				t = Date.now() - currentTime;
				left = 150 + r*Math.cos(alpha*t);
				Top = 350 + r*Math.sin(-alpha*t);
				$('.circle1').css({'left': left, 'top': Top});	
				break;
			case '2':
				t = Date.now() - currentTime + 500;
				left = 150 + r*Math.cos(alpha*t);
				Top = 350 + r*Math.sin(-alpha*t);
				$('.circle2').css({'left': left, 'top': Top});	
				break;
			case '3':
				t = Date.now() - currentTime + 1200;
				left = 150 + r*Math.cos(alpha*t);
				Top = 350 + r*Math.sin(-alpha*t);
				$('.circle3').css({'left': left, 'top': Top});
				break;
			case 'stop':
				clearInterval(startTime);
				break;
		}
	}, 1);
};

AS.SERVICES.showWaitWindow = function(){
	WaitCircles('1');
	WaitCircles('2');
	WaitCircles('3');
	$(".container").show();
};	

AS.SERVICES.hideWaitWindow = function(){
	WaitCircles('stop');
	$(".container").hide();
};	

var authFunc = function(){
	jQuery(".submit").on( "click", function(event){
		AS.SERVICES.showWaitWindow();
        AS.OPTIONS.login = $("input#login").val();
        AS.OPTIONS.password = $("input#password").val();
		portal.createPlayer();
		$(".form_player_container").show();
		$(".login-form").remove();
		$(".saveBtn").show();
    });
};

AS.SERVICES.unAuthorized = function()
{
	$(".container").hide();
	$(".login-form").remove();
	CreateAuthForm();
};

$(document).ready(function(){
	CreateAuthForm();
	$(".error").hide();
	$(".saveBtn").hide();
	$(".container").hide();
	$(".MsgRect").hide();
	
	$(".saveBtn").on("click", function(event){
		AS.SERVICES.showWaitWindow();
		portal.saveData();
	});	
});
